package com.textura.cpms.service.impl;

import com.textura.cpms.service.QueryMetaData

class PersonQueryBuilder {
	
	final QueryMetaData queryMetaData
	final List<String> propertyNames

	PersonQueryBuilder(QueryMetaData queryMetaData, String... propertyNames) {
		this.queryMetaData = queryMetaData
		this.propertyNames = propertyNames
	}

	String build() {
		def pqlBuf = new StringBuilder()
		
		pqlBuf << 'SELECT p.id'
		
		propertyNames.each { 
			pqlBuf << ',' << "p.$it"
		}
		pqlBuf << ' FROM Person p'
		
		if (queryMetaData.propertyName) {
			pqlBuf << ' WHERE p.'
			pqlBuf << queryMetaData.propertyName
			if (queryMetaData.searchTerm) {
				pqlBuf << ' = :searchTerm'
			}
			else {
				pqlBuf << ' IS NULL'
			}
		}
		
		if (queryMetaData.ascending) {
			pqlBuf << ' ORDER BY '
			queryMetaData.ascending.eachWithIndex { ascending, i ->
				if (i > 0) {
					pqlBuf << ','
				}
				pqlBuf << 'p.'
				pqlBuf << queryMetaData.orderBy[i]
				if (!queryMetaData.ascending[i]) {
					pqlBuf << ' DESC'
				}
			}
		}

		return pqlBuf.toString()
	}
}
