package com.textura.cpms.web.addressbook.data

import java.util.List

import org.testng.annotations.Test

import com.textura.cpms.model.Person
import com.textura.cpms.model.PersonReference
import com.textura.cpms.service.PersonManager
import com.textura.cpms.service.QueryMetaData

class PersonReferenceContainerTest {

	@Test
	void test() {

		def personManager = [ 
			findPersonReferences: { Object[] params ->
				return [ new PersonReference(1L, [firstName:'Austin', lastName: 'Powers', email: 'austimpowers@mi6.gov', phoneNumber: '123-456-7890', streetAddress:'123 Elm Street', postalCode:123456, city:'London']),
					new PersonReference(2L, [firstName:'Dr.', lastName: 'Evil', email: 'drevil@company.gov', phoneNumber: '098-765-4321', streetAddress:'321 Elm Street', postalCode:78901, city:'Belgium'])]
			}
		] as PersonManager
				
		def container = new PersonReferenceContainer(personManager)
		assert container.getContainerPropertyIds() == ['firstName', 'lastName', 'email', 'phoneNumber', 'streetAddress', 'postalCode', 'city']
		
		assert container.getType('firstName') == String
		assert container.getType('lastName') == String
		assert container.getType('email') == String
		assert container.getType('phoneNumber') == String
		assert container.getType('streetAddress') == String
		assert container.getType('postalCode') == Integer
		assert container.getType('city') == String
		
		assert !container.isOpen()
		container.refresh()
		assert container.isOpen()
		assert container.queryMetaData
		
		assert container.getItemIds() as List == [1L, 2L] 
		assert container.containsId(1L)
		assert container.getItem(1L) 
		assert container.getItem(1L).getItemProperty('firstName').value == 'Austin'
		assert container.getItem(1L).getItemProperty('lastName').value == 'Powers'
		assert container.getItem(1L).getItemProperty('email').value == 'austimpowers@mi6.gov'
		assert container.getItem(1L).getItemProperty('phoneNumber').value  == '123-456-7890'
		assert container.getItem(1L).getItemProperty('streetAddress').value == '123 Elm Street'
		assert container.getItem(1L).getItemProperty('postalCode').value == 123456
		assert container.getItem(1L).getItemProperty('city').value == 'London'

		assert container.getContainerProperty(1L, 'firstName').value == 'Austin'
		assert container.getContainerProperty(1L, 'lastName').value == 'Powers'
		assert container.getContainerProperty(1L, 'email').value == 'austimpowers@mi6.gov'
		assert container.getContainerProperty(1L, 'phoneNumber').value == '123-456-7890'
		assert container.getContainerProperty(1L, 'streetAddress').value == '123 Elm Street'
		assert container.getContainerProperty(1L, 'postalCode').value == 123456
		assert container.getContainerProperty(1L, 'city').value == 'London'
	}
}

